#include "include/day2_input.h"
#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <stdbool.h>
#include <string.h>
#include <sys/types.h>

struct list_ctx {
    void** list;
    size_t list_len;
};


struct list_ctx *parse_input_day2() {
    struct list_ctx *ctx = malloc(sizeof(struct list_ctx));
    ctx->list = malloc(1000 * sizeof(struct list_ctx));
    ctx->list_len = 1000;

    int list_i = 0;
    int report_buf_len = 0;
    int report_i = 0;
    char *report_buf = NULL; 
    ctx->list[list_i] = malloc(sizeof(struct list_ctx));
    ctx->list_len = 0;
    for(int i = 0; i < input_day2_txt_len; i++) {
        char c = input_day2_txt[i];
        struct list_ctx *report = ((struct list_ctx*) ctx->list[list_i]);
        switch(c) {
            case ' ': 
                if (report_buf_len) {
                    report->list = realloc(report->list, sizeof(u_int8_t) * (report_i+1));            
                    report->list[report_i] = malloc(sizeof(u_int8_t));
                    *(u_int8_t*) report->list[report_i] = strtoul(report_buf, NULL, 10);
                    report_buf_len = 0;
                    free(report_buf);
                    report_buf = NULL;
                    report_i++;
                    fprintf(stderr, "%lu", strtoul(report_buf, NULL, 10));
                };
                break;
            case '\n': { 
                    report->list = realloc(report->list, sizeof(u_int8_t) * (report_i+1));            
                    report->list[report_i] = malloc(sizeof(u_int8_t));
                    *(u_int8_t*) report->list[report_i] = strtoul(report_buf, NULL, 10);
                    list_i++;
                    report_buf_len = 0;
                    free(report_buf);
                    report_buf = NULL;
                    fprintf(stderr, "%lu\n", strtoul(report_buf, NULL, 10));
                    report_i = 0;
                break;
            }
            default: {
                report_buf = realloc(report_buf, (report_buf_len++) * sizeof(char));
                report_buf[report_buf_len-1] = c;
            }
        }
    }
    return ctx;
}



char* day_2_part_1() {
    struct list_ctx *ctx = parse_input_day2();
    int total = 0;

    for(int list_i = 0; list_i < ctx->list_len; list_i++) {
        struct list_ctx *report = ((struct list_ctx*) ctx->list[list_i]);
        bool safe = true;
        for(int report_i = 1; report_i < report->list_len && safe; report_i++) {
            int diff = *(u_int8_t*) report->list[report_i] - *(u_int8_t *) report->list[report_i];
            safe = diff < 3 && diff > -3;
        }
        total += safe;
    }

    int len = snprintf(NULL, 0, "%d", total) + 1;
    char *total_str = malloc(len);
    snprintf(total_str, len, "%d", total); 
        
    return total_str;
}
